Arch Roof: Difference between revisions

From FreeCAD Documentation
No edit summary
(Docnav)
(25 intermediate revisions by 6 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>

<!--T:30-->
{{Docnav
|[[Arch_Window|Window]]
|[[Arch_CompAxis|CompAxis]]
|[[Arch_Workbench|Arch]]
|IconL=Arch_Window.svg
|IconR=Arch_CompAxis.png
|IconC=Workbench_Arch.svg
}}

<!--T:13-->
<!--T:13-->
{{GuiCommand
{{GuiCommand|Name=Arch Roof|Workbenches=[[Arch Module|Arch]]|MenuLocation=Arch → Roof|Shortcut=R F}}
|Name=Arch Roof
|MenuLocation=Arch → Roof
|Workbenches=[[Arch_Workbench|Arch]]
|Shortcut={{KEY|R}} {{KEY|F}}
|SeeAlso=[[Arch_Structure|Arch Structure]], [[Arch_Wall|Arch Wall]]
}}


==Description== <!--T:14-->
==Description== <!--T:14-->


<!--T:15-->
<!--T:15-->
The Roof tool allows you to create a sloped roof from a selected wire. The created roof object is parametric, keeping its relationship with the base object. Please note that this tool is still in development, and might fail with very complex shapes. The principle is that each edge is seen allotting a profile of roof (slope, width, overhang, thickness…).
The {{Button|[[Image:Arch Roof.svg|16px]] [[Arch_Roof|Arch Roof]]}} tool allows for the creation of a sloped roof from a selected wire. The created roof object is parametric, keeping its relationship with the base object. The principle is that each edge is seen allotting a profile of roof (slope, width, overhang, thickness).


<!--T:16-->
<!--T:29-->
'''Note:''' This tool is still in development, and might fail with very complex shapes.

</translate>
[[Image:RoofExample.png|600px]]
[[Image:RoofExample.png|600px]]
<translate>
<!--T:16-->
{{Caption|View from above a building model showing the roof with certain transparency}}


==How to use== <!--T:17-->
==Usage== <!--T:17-->


<!--T:18-->
<!--T:18-->
# Create a wire with following the counterclockwise direction and select it.
# Create a wire with following the counter-clockwise direction and select it.
#*[[Image:CounterclockwiseWire.png|600px]]
#:[[Image:CounterclockwiseWire.png|600px]]
# Press the {{KEY|[[Image:Arch Roof.png|16px]] [[Arch Roof]]}} button, or press {{KEY|R}} then {{KEY|F}} keys
# Press the {{Button|[[Image:Arch Roof.svg|16px]] [[Arch Roof|Arch Roof]]}} button, or press {{KEY|R}} then {{KEY|F}} keys
# The default roof object could have a strange shape, it's because the tool have not all the needed informations.
# The default roof object could have a strange shape, it's because the tool is missing some necessary information.
# After creating the default roof, double click on the object in the tree view to access and edit all the properties. Angle must be between 0 and 90.
# After creating the default roof, double click on the object in the [[tree view]] to access and edit all the properties. Angle must be between 0 and 90.
#*[[File:RoofTable.png]]
#:[[File:RoofTable.png]]
# Each line correspond to a roof pane. So you can set properties you want for each roof pane.
# Each line corresponds to a roof pane. So you can set the properties you want for each roof pane.
# To help you, you can set Angle or Run to 0 and defined a Relative Id, this make automatic calculs to find the data relative to the relative Id.
# To help you, you can set {{incode|Angle}} or {{incode|Run}} to {{incode|0}} and define a {{incode|Relative Id}}, this makes an automatic calculation to find the data relative to the {{incode|Relative Id}}.
# It work like this :
# It works like this:
## If Angle = 0 and Run = 0 then profile is identical to the relative profile.
## If {{incode|Angle &#61; 0}} and {{incode|Run &#61; 0}} then profile is identical to the relative profile.
## If Angle = 0 then angle is calculated so that the height is the same one as the relative profile.
## If {{incode|Angle &#61; 0}} then {{incode|Angle}} is calculated so that the height is the same one as the relative profile.
## If Run = 0 then Run is calculated so that the height is the same one as the relative profile.
## If {{incode|Run &#61; 0}} then {{incode|Run}} is calculated so that the height is the same one as the relative profile.
# At the end, set an angle to 90° to make a gable.
# Finally, set an Angle to 90° to make a gable.
#*[[Image:RoofProfil.png|600px]]
#:[[Image:RoofProfil.png|600px]]
# '''Also you can check this video''' : https://www.youtube.com/watch?v=4Urwru71dVk
# {{Emphasis|Note}}: for better comprehension, please see this [https://www.youtube.com/watch?v=4Urwru71dVk youtube clip].


==Options== <!--T:26-->
==Options== <!--T:26-->


<!--T:27-->
<!--T:27-->
* Roofs share the common properties and behaviours of all [[Arch Component|Arch Components]]
* Roofs share the common properties and behaviors of all [[Arch Component|Arch Components]]


==Properties== <!--T:20-->
==Properties== <!--T:20-->
Line 41: Line 64:
* {{PropertyData|Angles}}: List of the slope angle of the roof pane (an angle for each edge in the wire).
* {{PropertyData|Angles}}: List of the slope angle of the roof pane (an angle for each edge in the wire).
* {{PropertyData|Runs}}: List of the width of the roof pane (a run for each edge in the wire).
* {{PropertyData|Runs}}: List of the width of the roof pane (a run for each edge in the wire).
* {{PropertyData|IdRel}}: List of relation Id The slope angle of the roof
* {{PropertyData|IdRel}}: List of relation Id of the slope angle of the roof.
* {{PropertyData|Thickness}}: List of thickness of the roof pane. (a thickness for each edge in the wire).
* {{PropertyData|Thickness}}: List of thickness of the roof pane. (a thickness for each edge in the wire).
* {{PropertyData|Overhang}}: List of the overhang of the roof pane (an overhang for each edge in the wire).
* {{PropertyData|Overhang}}: List of the overhang of the roof pane (an overhang for each edge in the wire).
* {{PropertyData|Face}}: The face index of the base object to be used #Not really used
* {{PropertyData|Face}}: The face index of the base object to be used (not really used).


==Scripting== <!--T:22-->
==Scripting== <!--T:22-->
{{Emphasis|See also:}} [[Arch API|Arch API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].


<!--T:23-->
<!--T:23-->
The Roof tool can by used in [[macros]] and from the python console by using the following function:
The Roof tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
</translate>
</translate>
{{Code|code=
{{Code|code=
makeRoof (baseobj,[facenr],[angles],[runs],[idrel],[thickness],[overhang],[name])
Roof = makeRoof(baseobj=None, facenr=0, angles=[45.,], run=[], idrel=[0,], thickness=[50.,], overhang=[100.,], name="Roof")
}}
}}
<translate>
<translate>

<!--T:24-->
<!--T:24-->
* Creates a {{incode|Roof}} object from the given {{incode|baseobj}}, which can be a closed wire or a solid object.
:Makes a roof based on a closed wire. You can provide a list of angles, run, idrel, thickness, overhang for each edges in the wire to define the roof shape. The default for angle is 45 and the list is automatically complete to match with number of edges in the wire.
** If {{incode|baseobj}} is a wire, you can provide lists for {{incode|angles}}, {{incode|run}}, {{incode|idrel}}, {{incode|thickness}}, and {{incode|overhang}}, for each edge in the wire to define the shape of the roof.
** The lists are automatically completed to match the number of edges in the wire.


<!--T:25-->
<!--T:25-->
Example:
Example:

</translate>
</translate>
{{Code|code=
{{Code|code=
import FreeCAD as App
import Arch, Draft
import Arch, Draft
rect = Draft.makeRectangle(30,40)
Arch.makeRoof(rect,angles=[30.,])
}}


doc = App.newDocument()

rect = Draft.makeRectangle(3000, 4000)
doc.recompute()

roof = Arch.makeRoof(rect, angles=[30.,])

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(0, 2000, 0)

wire = Draft.make_wire([p1, p2, p3], closed=True)
doc.recompute()

roof1 = Arch.makeRoof(wire)

doc.recompute()
}}
<translate>
<translate>

[[Category:Arch]]

<!--T:28-->
{{Docnav
|[[Arch_Window|Window]]
|[[Arch_CompAxis|CompAxis]]
|[[Arch_Workbench|Arch]]
|IconL=Arch_Window.svg
|IconR=Arch_CompAxis.png
|IconC=Workbench_Arch.svg
}}

</translate>
</translate>
{{Arch Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Revision as of 13:58, 9 March 2022

Arch Roof

Menu location
Arch → Roof
Workbenches
Arch
Default shortcut
R F
Introduced in version
-
See also
Arch Structure, Arch Wall

Description

The Arch Roof tool allows for the creation of a sloped roof from a selected wire. The created roof object is parametric, keeping its relationship with the base object. The principle is that each edge is seen allotting a profile of roof (slope, width, overhang, thickness).

Note: This tool is still in development, and might fail with very complex shapes.

View from above a building model showing the roof with certain transparency

Usage

  1. Create a wire with following the counter-clockwise direction and select it.
  2. Press the Arch Roof button, or press R then F keys
  3. The default roof object could have a strange shape, it's because the tool is missing some necessary information.
  4. After creating the default roof, double click on the object in the tree view to access and edit all the properties. Angle must be between 0 and 90.
  5. Each line corresponds to a roof pane. So you can set the properties you want for each roof pane.
  6. To help you, you can set Angle or Run to 0 and define a Relative Id, this makes an automatic calculation to find the data relative to the Relative Id.
  7. It works like this:
    1. If Angle = 0 and Run = 0 then profile is identical to the relative profile.
    2. If Angle = 0 then Angle is calculated so that the height is the same one as the relative profile.
    3. If Run = 0 then Run is calculated so that the height is the same one as the relative profile.
  8. Finally, set an Angle to 90° to make a gable.
  9. Note: for better comprehension, please see this youtube clip.

Options

Properties

  • DataAngles: List of the slope angle of the roof pane (an angle for each edge in the wire).
  • DataRuns: List of the width of the roof pane (a run for each edge in the wire).
  • DataIdRel: List of relation Id of the slope angle of the roof.
  • DataThickness: List of thickness of the roof pane. (a thickness for each edge in the wire).
  • DataOverhang: List of the overhang of the roof pane (an overhang for each edge in the wire).
  • DataFace: The face index of the base object to be used (not really used).

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Roof tool can be used in macros and from the Python console by using the following function:

Roof = makeRoof(baseobj=None, facenr=0, angles=[45.,], run=[], idrel=[0,], thickness=[50.,], overhang=[100.,], name="Roof")
  • Creates a Roof object from the given baseobj, which can be a closed wire or a solid object.
    • If baseobj is a wire, you can provide lists for angles, run, idrel, thickness, and overhang, for each edge in the wire to define the shape of the roof.
    • The lists are automatically completed to match the number of edges in the wire.

Example:

import FreeCAD as App
import Arch, Draft

doc = App.newDocument()

rect = Draft.makeRectangle(3000, 4000)
doc.recompute()

roof = Arch.makeRoof(rect, angles=[30.,])

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(0, 2000, 0)

wire = Draft.make_wire([p1, p2, p3], closed=True)
doc.recompute()

roof1 = Arch.makeRoof(wire)

doc.recompute()